diff --git a/doc/src/sgml/dict-xsyn.sgml b/doc/src/sgml/dict-xsyn.sgml
index a94c6430ed4..6da50a856c6 100644
--- a/doc/src/sgml/dict-xsyn.sgml
+++ b/doc/src/sgml/dict-xsyn.sgml
@@ -14,7 +14,7 @@
   search for a word using any of its synonyms.
  </para>
 
- <sect2 id="dict-xsyn-config">
+ <sect2 id="dict-xsyn-config" xreflabel="Configuration">
   <title>Configuration</title>
 
   <para>
@@ -83,7 +83,7 @@ word syn1 syn2 syn3
   </para>
  </sect2>
 
- <sect2 id="dict-xsyn-usage">
+ <sect2 id="dict-xsyn-usage" xreflabel="Usage">
   <title>Usage</title>
 
   <para>
diff --git a/doc/src/sgml/dml.sgml b/doc/src/sgml/dml.sgml
index 61c64cf6c49..a06e329f96b 100644
--- a/doc/src/sgml/dml.sgml
+++ b/doc/src/sgml/dml.sgml
@@ -12,7 +12,7 @@
   from the database.
  </para>
 
- <sect1 id="dml-insert">
+ <sect1 id="dml-insert" xreflabel="Inserting Data">
   <title>Inserting Data</title>
 
   <indexterm zone="dml-insert">
@@ -122,7 +122,7 @@ INSERT INTO products (product_no, name, price)
   </tip>
  </sect1>
 
- <sect1 id="dml-update">
+ <sect1 id="dml-update" xreflabel="Updating Data">
   <title>Updating Data</title>
 
   <indexterm zone="dml-update">
@@ -217,7 +217,7 @@ UPDATE mytable SET a = 5, b = 3, c = 1 WHERE a &gt; 0;
   </para>
  </sect1>
 
- <sect1 id="dml-delete">
+ <sect1 id="dml-delete" xreflabel="Deleting Data">
   <title>Deleting Data</title>
 
   <indexterm zone="dml-delete">
@@ -261,7 +261,7 @@ DELETE FROM products;
   </para>
  </sect1>
 
- <sect1 id="dml-returning">
+ <sect1 id="dml-returning" xreflabel="Returning Data from Modified Rows">
   <title>Returning Data from Modified Rows</title>
 
   <indexterm zone="dml-returning">
diff --git a/doc/src/sgml/docguide.sgml b/doc/src/sgml/docguide.sgml
index 7b61b4841aa..2c8954a191c 100644
--- a/doc/src/sgml/docguide.sgml
+++ b/doc/src/sgml/docguide.sgml
@@ -42,7 +42,7 @@
   download.
  </para>
 
- <sect1 id="docguide-docbook">
+ <sect1 id="docguide-docbook" xreflabel="DocBook">
   <title>DocBook</title>
   <para>
    The documentation sources are written in
@@ -69,7 +69,7 @@
  </sect1>
 
 
- <sect1 id="docguide-toolsets">
+ <sect1 id="docguide-toolsets" xreflabel="Tool Sets">
   <title>Tool Sets</title>
 
   <para>
@@ -150,7 +150,7 @@
    here.
   </para>
 
-  <sect2 id="docguide-toolsets-inst-fedora-et-al">
+  <sect2 id="docguide-toolsets-inst-fedora-et-al" xreflabel="Installation on Fedora, RHEL, and Derivatives">
    <title>Installation on Fedora, RHEL, and Derivatives</title>
 
    <para>
@@ -161,7 +161,7 @@ yum install docbook-dtds docbook-style-xsl libxslt fop
    </para>
   </sect2>
 
-  <sect2 id="docguide-toolsets-inst-freebsd">
+  <sect2 id="docguide-toolsets-inst-freebsd" xreflabel="Installation on FreeBSD">
    <title>Installation on FreeBSD</title>
 
    <para>
@@ -178,7 +178,7 @@ pkg install docbook-xml docbook-xsl libxslt fop
    </para>
   </sect2>
 
-  <sect2 id="docguide-toolsets-inst-debian">
+  <sect2 id="docguide-toolsets-inst-debian" xreflabel="Debian Packages">
    <title>Debian Packages</title>
 
    <para>
@@ -191,7 +191,7 @@ apt-get install docbook-xml docbook-xsl libxml2-utils xsltproc fop
    </para>
   </sect2>
 
-  <sect2 id="docguide-toolsets-inst-macos">
+  <sect2 id="docguide-toolsets-inst-macos" xreflabel="macOS">
    <title>macOS</title>
 
    <para>
@@ -232,7 +232,7 @@ postgres.sgml:21: warning: failed to load external entity "http://www.oasis-open
    </para>
   </sect2>
 
-  <sect2 id="docguide-toolsets-configure">
+  <sect2 id="docguide-toolsets-configure" xreflabel="Detection by configure">
    <title>Detection by <command>configure</command></title>
 
   <para>
@@ -272,7 +272,7 @@ checking for dbtoepub... dbtoepub
   </sect2>
  </sect1>
 
- <sect1 id="docguide-build">
+ <sect1 id="docguide-build" xreflabel="Building the Documentation with Make">
   <title>Building the Documentation with Make</title>
 
   <para>
@@ -282,7 +282,7 @@ checking for dbtoepub... dbtoepub
    documentation. (Remember to use GNU make.)
   </para>
 
-  <sect2 id="docguide-build-html">
+  <sect2 id="docguide-build-html" xreflabel="HTML">
    <title>HTML</title>
 
    <para>
@@ -311,7 +311,7 @@ checking for dbtoepub... dbtoepub
    </para>
  </sect2>
 
- <sect2 id="docguide-build-manpages">
+ <sect2 id="docguide-build-manpages" xreflabel="Manpages">
   <title>Manpages</title>
 
   <para>
@@ -325,7 +325,7 @@ checking for dbtoepub... dbtoepub
   </para>
  </sect2>
 
-  <sect2 id="docguide-build-pdf">
+  <sect2 id="docguide-build-pdf" xreflabel="PDF">
    <title>PDF</title>
 
    <para>
@@ -391,7 +391,7 @@ LOGLEVEL=-Dorg.apache.commons.logging.simplelog.defaultlog=WARN
    </para>
   </sect2>
 
-  <sect2 id="docguide-build-syntax-check">
+  <sect2 id="docguide-build-syntax-check" xreflabel="Syntax Check">
    <title>Syntax Check</title>
 
    <para>
@@ -406,7 +406,7 @@ LOGLEVEL=-Dorg.apache.commons.logging.simplelog.defaultlog=WARN
  </sect1>
 
 
- <sect1 id="docguide-build-meson">
+ <sect1 id="docguide-build-meson" xreflabel="Building the Documentation with Meson">
   <title>Building the Documentation with Meson</title>
 
    <para>
@@ -429,7 +429,7 @@ LOGLEVEL=-Dorg.apache.commons.logging.simplelog.defaultlog=WARN
  </sect1>
 
 
- <sect1 id="docguide-authoring">
+ <sect1 id="docguide-authoring" xreflabel="Documentation Authoring">
   <title>Documentation Authoring</title>
 
    <para>
@@ -446,7 +446,7 @@ LOGLEVEL=-Dorg.apache.commons.logging.simplelog.defaultlog=WARN
     correct mode.
    </para>
 
-   <sect2 id="docguide-authoring-emacs">
+   <sect2 id="docguide-authoring-emacs" xreflabel="Emacs">
     <title>Emacs</title>
 
     <para>
@@ -469,10 +469,10 @@ LOGLEVEL=-Dorg.apache.commons.logging.simplelog.defaultlog=WARN
  </sect1>
 
 
- <sect1 id="docguide-style">
+ <sect1 id="docguide-style" xreflabel="Style Guide">
   <title>Style Guide</title>
 
-  <sect2 id="docguide-style-ref-pages">
+  <sect2 id="docguide-style-ref-pages" xreflabel="Reference Pages">
    <title>Reference Pages</title>
 
    <para>
diff --git a/doc/src/sgml/earthdistance.sgml b/doc/src/sgml/earthdistance.sgml
index 5a709e3d476..b0414b13129 100644
--- a/doc/src/sgml/earthdistance.sgml
+++ b/doc/src/sgml/earthdistance.sgml
@@ -44,7 +44,7 @@
   </para>
  </caution>
 
- <sect2 id="earthdistance-cube-based">
+ <sect2 id="earthdistance-cube-based" xreflabel="Cube-Based Earth Distances">
   <title>Cube-Based Earth Distances</title>
 
   <para>
@@ -202,7 +202,7 @@
 
  </sect2>
 
- <sect2 id="earthdistance-point-based">
+ <sect2 id="earthdistance-point-based" xreflabel="Point-Based Earth Distances">
   <title>Point-Based Earth Distances</title>
 
   <para>
diff --git a/doc/src/sgml/ecpg.sgml b/doc/src/sgml/ecpg.sgml
index 807dadcb4a3..802315850f0 100644
--- a/doc/src/sgml/ecpg.sgml
+++ b/doc/src/sgml/ecpg.sgml
@@ -22,7 +22,7 @@
   many resources about SQL.
  </para>
 
- <sect1 id="ecpg-concept">
+ <sect1 id="ecpg-concept" xreflabel="The Concept">
   <title>The Concept</title>
 
   <para>
@@ -86,7 +86,7 @@ EXEC SQL ...;
   </para>
  </sect1>
 
- <sect1 id="ecpg-connect">
+ <sect1 id="ecpg-connect" xreflabel="Managing Database Connections">
   <title>Managing Database Connections</title>
 
   <para>
@@ -94,7 +94,7 @@ EXEC SQL ...;
    connections.
   </para>
 
-  <sect2 id="ecpg-connecting">
+  <sect2 id="ecpg-connecting" xreflabel="Connecting to the Database Server">
    <title>Connecting to the Database Server</title>
 
   <para>
@@ -271,7 +271,7 @@ EXEC SQL CONNECT TO :target USER :user USING :passwd;
   </para>
   </sect2>
 
-  <sect2 id="ecpg-set-connection">
+  <sect2 id="ecpg-set-connection" xreflabel="Choosing a Connection">
    <title>Choosing a Connection</title>
 
   <para>
@@ -394,7 +394,7 @@ postgres
   </para>
   </sect2>
 
-  <sect2 id="ecpg-disconnect">
+  <sect2 id="ecpg-disconnect" xreflabel="Closing a Connection">
    <title>Closing a Connection</title>
 
   <para>
@@ -437,7 +437,7 @@ EXEC SQL DISCONNECT <optional><replaceable>connection</replaceable></optional>;
 
  </sect1>
 
- <sect1 id="ecpg-commands">
+ <sect1 id="ecpg-commands" xreflabel="Running SQL Commands">
   <title>Running SQL Commands</title>
 
   <para>
@@ -445,7 +445,7 @@ EXEC SQL DISCONNECT <optional><replaceable>connection</replaceable></optional>;
    Below are some examples of how to do that.
   </para>
 
-  <sect2 id="ecpg-executing">
+  <sect2 id="ecpg-executing" xreflabel="Executing SQL Statements">
    <title>Executing SQL Statements</title>
 
   <para>
@@ -517,7 +517,7 @@ EXEC SQL SHOW search_path INTO :var;
   </para>
   </sect2>
 
-  <sect2 id="ecpg-cursors">
+  <sect2 id="ecpg-cursors" xreflabel="Using Cursors">
    <title>Using Cursors</title>
 
   <para>
@@ -558,7 +558,7 @@ EXEC SQL COMMIT;
    </note>
   </sect2>
 
-  <sect2 id="ecpg-transactions">
+  <sect2 id="ecpg-transactions" xreflabel="Managing Transactions">
    <title>Managing Transactions</title>
 
   <para>
@@ -644,7 +644,7 @@ EXEC SQL COMMIT;
    </para>
   </sect2>
 
-  <sect2 id="ecpg-prepared">
+  <sect2 id="ecpg-prepared" xreflabel="Prepared Statements">
    <title>Prepared Statements</title>
 
    <para>
@@ -714,7 +714,7 @@ EXEC SQL DEALLOCATE PREPARE <replaceable>name</replaceable>;
   </sect2>
  </sect1>
 
- <sect1 id="ecpg-variables">
+ <sect1 id="ecpg-variables" xreflabel="Using Host Variables">
   <title>Using Host Variables</title>
 
   <para>
@@ -739,7 +739,7 @@ EXEC SQL DEALLOCATE PREPARE <replaceable>name</replaceable>;
    in <xref linkend="ecpg-descriptors"/>.
   </para>
 
-  <sect2 id="ecpg-variables-overview">
+  <sect2 id="ecpg-variables-overview" xreflabel="Overview">
    <title>Overview</title>
 
    <para>
@@ -764,7 +764,7 @@ EXEC SQL INSERT INTO sometable VALUES (:v1, 'foo', :v2);
    </para>
   </sect2>
 
-  <sect2 id="ecpg-declare-sections">
+  <sect2 id="ecpg-declare-sections" xreflabel="Declare Sections">
    <title>Declare Sections</title>
 
    <para>
@@ -815,7 +815,7 @@ EXEC SQL int i = 4;
    </para>
   </sect2>
 
-  <sect2 id="ecpg-retrieving">
+  <sect2 id="ecpg-retrieving" xreflabel="Retrieving Query Results">
    <title>Retrieving Query Results</title>
 
    <para>
@@ -882,7 +882,7 @@ do
 
   </sect2>
 
-  <sect2 id="ecpg-variables-type-mapping">
+  <sect2 id="ecpg-variables-type-mapping" xreflabel="Type Mapping">
    <title>Type Mapping</title>
 
    <para>
@@ -1017,7 +1017,7 @@ do
     </tgroup>
    </table>
 
-   <sect3 id="ecpg-char">
+   <sect3 id="ecpg-char" xreflabel="Handling Character Strings">
     <title>Handling Character Strings</title>
 
     <para>
@@ -1077,7 +1077,7 @@ struct varchar_var { int len; char arr[180]; } var;
     </para>
    </sect3>
 
-   <sect3 id="ecpg-special-types">
+   <sect3 id="ecpg-special-types" xreflabel="Accessing Special Data Types">
     <title>Accessing Special Data Types</title>
 
     <para>
@@ -1104,7 +1104,7 @@ struct varchar_var { int len; char arr[180]; } var;
      see <xref linkend="ecpg-pgtypes"/>.
     </para>
 
-    <sect4 id="ecpg-special-types-timestamp-date">
+    <sect4 id="ecpg-special-types-timestamp-date" xreflabel="timestamp, date">
      <title>timestamp, date</title>
 
      <para>
@@ -1156,7 +1156,7 @@ ts = 2010-06-27 18:03:56.949343
      </para>
     </sect4>
 
-    <sect4 id="ecpg-type-interval">
+    <sect4 id="ecpg-type-interval" xreflabel="interval">
      <title>interval</title>
 
      <para>
@@ -1198,7 +1198,7 @@ EXEC SQL END DECLARE SECTION;
      </para>
     </sect4>
 
-    <sect4 id="ecpg-type-numeric-decimal">
+    <sect4 id="ecpg-type-numeric-decimal" xreflabel="numeric, decimal">
      <title>numeric, decimal</title>
 
      <para>
@@ -1269,7 +1269,7 @@ EXEC SQL END DECLARE SECTION;
      </para>
     </sect4>
 
-    <sect4 id="ecpg-special-types-bytea">
+    <sect4 id="ecpg-special-types-bytea" xreflabel="bytea">
      <title>bytea</title>
 
      <para>
@@ -1300,7 +1300,7 @@ struct bytea_var { int len; char arr[180]; } var;
     </sect4>
    </sect3>
 
-   <sect3 id="ecpg-variables-nonprimitive-c">
+   <sect3 id="ecpg-variables-nonprimitive-c" xreflabel="Host Variables with Nonprimitive Types">
     <title>Host Variables with Nonprimitive Types</title>
 
     <para>
@@ -1308,7 +1308,7 @@ struct bytea_var { int len; char arr[180]; } var;
      pointers.
     </para>
 
-    <sect4 id="ecpg-variables-arrays">
+    <sect4 id="ecpg-variables-arrays" xreflabel="Arrays">
      <title>Arrays</title>
 
      <para>
@@ -1371,7 +1371,7 @@ oid=0, dbname=
      </para>
     </sect4>
 
-    <sect4 id="ecpg-variables-struct">
+    <sect4 id="ecpg-variables-struct" xreflabel="Structures">
      <title>Structures</title>
 
      <para>
@@ -1475,7 +1475,7 @@ EXEC SQL END DECLARE SECTION;
      </para>
     </sect4>
 
-    <sect4 id="ecpg-variables-nonprimitive-c-typedefs">
+    <sect4 id="ecpg-variables-nonprimitive-c-typedefs" xreflabel="Typedefs">
      <title>Typedefs</title>
      <indexterm>
       <primary>typedef</primary>
@@ -1532,7 +1532,7 @@ EXEC SQL START TRANSACTION;
      </note>
     </sect4>
 
-    <sect4 id="ecpg-variables-nonprimitive-c-pointers">
+    <sect4 id="ecpg-variables-nonprimitive-c-pointers" xreflabel="Pointers">
      <title>Pointers</title>
 
      <para>
@@ -1554,7 +1554,7 @@ EXEC SQL END DECLARE SECTION;
    </sect3>
   </sect2>
 
-  <sect2 id="ecpg-variables-nonprimitive-sql">
+  <sect2 id="ecpg-variables-nonprimitive-sql" xreflabel="Handling Nonprimitive SQL Data Types">
    <title>Handling Nonprimitive SQL Data Types</title>
 
    <para>
@@ -1564,7 +1564,7 @@ EXEC SQL END DECLARE SECTION;
     nonprimitive types, described in the previous section.
    </para>
 
-   <sect3 id="ecpg-variables-nonprimitive-sql-arrays">
+   <sect3 id="ecpg-variables-nonprimitive-sql-arrays" xreflabel="Arrays">
     <title>Arrays</title>
 
     <para>
@@ -1687,7 +1687,7 @@ while (1)
     </para>
    </sect3>
 
-   <sect3 id="ecpg-variables-nonprimitive-sql-composite">
+   <sect3 id="ecpg-variables-nonprimitive-sql-composite" xreflabel="Composite Types">
     <title>Composite Types</title>
 
     <para>
@@ -1807,7 +1807,7 @@ while (1)
     </para>
    </sect3>
 
-   <sect3 id="ecpg-variables-nonprimitive-sql-user-defined-base-types">
+   <sect3 id="ecpg-variables-nonprimitive-sql-user-defined-base-types" xreflabel="User-Defined Base Types">
     <title>User-Defined Base Types</title>
 
     <para>
@@ -1895,7 +1895,7 @@ EXEC SQL INSERT INTO test_complex VALUES ('(1,2)', '(3,4)');
    </sect3>
   </sect2>
 
-  <sect2 id="ecpg-indicators">
+  <sect2 id="ecpg-indicators" xreflabel="Indicators">
    <title>Indicators</title>
 
    <para>
@@ -1943,7 +1943,7 @@ EXEC SQL SELECT b INTO :val :val_ind FROM test1;
   </sect2>
  </sect1>
 
- <sect1 id="ecpg-dynamic">
+ <sect1 id="ecpg-dynamic" xreflabel="Dynamic SQL">
   <title>Dynamic SQL</title>
 
   <para>
@@ -1956,7 +1956,7 @@ EXEC SQL SELECT b INTO :val :val_ind FROM test1;
    provide in a string variable.
   </para>
 
-  <sect2 id="ecpg-dynamic-without-result">
+  <sect2 id="ecpg-dynamic-without-result" xreflabel="Executing Statements without a Result Set">
    <title>Executing Statements without a Result Set</title>
 
    <para>
@@ -1978,7 +1978,7 @@ EXEC SQL EXECUTE IMMEDIATE :stmt;
    </para>
   </sect2>
 
-  <sect2 id="ecpg-dynamic-input">
+  <sect2 id="ecpg-dynamic-input" xreflabel="Executing a Statement with Input Parameters">
    <title>Executing a Statement with Input Parameters</title>
 
    <para>
@@ -2009,7 +2009,7 @@ EXEC SQL DEALLOCATE PREPARE <replaceable>name</replaceable>;
    </para>
   </sect2>
 
-  <sect2 id="ecpg-dynamic-with-result">
+  <sect2 id="ecpg-dynamic-with-result" xreflabel="Executing a Statement with a Result Set">
    <title>Executing a Statement with a Result Set</title>
 
    <para>
@@ -2072,7 +2072,7 @@ EXEC SQL DISCONNECT ALL;
   </sect2>
  </sect1>
 
- <sect1 id="ecpg-pgtypes">
+ <sect1 id="ecpg-pgtypes" xreflabel="pgtypes Library">
   <title>pgtypes Library</title>
 
   <para>
@@ -2099,7 +2099,7 @@ PGTYPESchar_free(out);
 </programlisting>
   </para>
 
-  <sect2 id="ecpg-pgtypes-cstrings">
+  <sect2 id="ecpg-pgtypes-cstrings" xreflabel="Character Strings">
    <title>Character Strings</title>
    <para>
    Some functions such as <function>PGTYPESnumeric_to_asc</function> return
@@ -2111,7 +2111,7 @@ PGTYPESchar_free(out);
    </para>
   </sect2>
 
-  <sect2 id="ecpg-pgtypes-numeric">
+  <sect2 id="ecpg-pgtypes-numeric" xreflabel="The numeric Type">
    <title>The numeric Type</title>
    <para>
     The numeric type offers to do calculations with arbitrary precision. See
@@ -2436,7 +2436,7 @@ int PGTYPESnumeric_from_decimal(decimal *src, numeric *dst);
    </para>
   </sect2>
 
-  <sect2 id="ecpg-pgtypes-date">
+  <sect2 id="ecpg-pgtypes-date" xreflabel="The date Type">
    <title>The date Type</title>
    <para>
     The date type in C enables your programs to deal with data of the SQL type
@@ -2914,7 +2914,7 @@ int PGTYPESdate_defmt_asc(date *d, char *fmt, char *str);
    </para>
   </sect2>
 
-  <sect2 id="ecpg-pgtypes-timestamp">
+  <sect2 id="ecpg-pgtypes-timestamp" xreflabel="The timestamp Type">
    <title>The timestamp Type</title>
    <para>
     The timestamp type in C enables your programs to deal with data of the SQL
@@ -3444,7 +3444,7 @@ int PGTYPEStimestamp_sub_interval(timestamp *tin, interval *span, timestamp *tou
    </para>
   </sect2>
 
-  <sect2 id="ecpg-pgtypes-interval">
+  <sect2 id="ecpg-pgtypes-interval" xreflabel="The interval Type">
    <title>The interval Type</title>
    <para>
     The interval type in C enables your programs to deal with data of the SQL
@@ -3532,7 +3532,7 @@ int PGTYPESinterval_copy(interval *intvlsrc, interval *intvldest);
    </para>
   </sect2>
 
-  <sect2 id="ecpg-pgtypes-decimal">
+  <sect2 id="ecpg-pgtypes-decimal" xreflabel="The decimal Type">
    <title>The decimal Type</title>
    <para>
      The decimal type is similar to the numeric type. However it is limited to
@@ -3576,7 +3576,7 @@ void PGTYPESdecimal_free(decimal *var);
    </para>
   </sect2>
 
-   <sect2 id="ecpg-pgtypes-errno">
+   <sect2 id="ecpg-pgtypes-errno" xreflabel="errno Values of pgtypeslib">
     <title>errno Values of pgtypeslib</title>
    <para>
     <variablelist>
@@ -3718,7 +3718,7 @@ void PGTYPESdecimal_free(decimal *var);
    </para>
   </sect2>
 
-   <sect2 id="ecpg-pgtypes-constants">
+   <sect2 id="ecpg-pgtypes-constants" xreflabel="Special Constants of pgtypeslib">
     <title>Special Constants of pgtypeslib</title>
    <para>
     <variablelist>
@@ -3744,7 +3744,7 @@ void PGTYPESdecimal_free(decimal *var);
   </sect2>
  </sect1>
 
- <sect1 id="ecpg-descriptors">
+ <sect1 id="ecpg-descriptors" xreflabel="Using Descriptor Areas">
   <title>Using Descriptor Areas</title>
 
   <para>
@@ -3759,7 +3759,7 @@ void PGTYPESdecimal_free(decimal *var);
    SQLDAs.
   </para>
 
-  <sect2 id="ecpg-named-descriptors">
+  <sect2 id="ecpg-named-descriptors" xreflabel="Named SQL Descriptor Areas">
    <title>Named SQL Descriptor Areas</title>
 
    <para>
@@ -4017,7 +4017,7 @@ EXEC SQL GET DESCRIPTOR mydesc VALUE 1 :id = DATA;
 
   </sect2>
 
-  <sect2 id="ecpg-sqlda-descriptors">
+  <sect2 id="ecpg-sqlda-descriptors" xreflabel="SQLDA Descriptor Areas">
    <title>SQLDA Descriptor Areas</title>
 
    <para>
@@ -4054,7 +4054,7 @@ EXEC SQL DESCRIBE prepared_statement INTO mysqlda;
      <step><simpara>Free the memory area allocated for the input SQLDA.</simpara></step>
     </procedure>
 
-   <sect3 id="ecpg-sqlda-descriptors-sqlda">
+   <sect3 id="ecpg-sqlda-descriptors-sqlda" xreflabel="SQLDA Data Structure">
     <title>SQLDA Data Structure</title>
 
     <para>
@@ -4071,7 +4071,7 @@ EXEC SQL DESCRIBE prepared_statement INTO mysqlda;
      </para>
     </tip>
 
-    <sect4 id="ecpg-sqlda-sqlda">
+    <sect4 id="ecpg-sqlda-sqlda" xreflabel="sqlda_t Structure">
      <title>sqlda_t Structure</title>
 
      <para>
@@ -4169,7 +4169,7 @@ typedef struct sqlda_struct sqlda_t;
      </para>
     </sect4>
 
-    <sect4 id="ecpg-sqlda-sqlvar">
+    <sect4 id="ecpg-sqlda-sqlvar" xreflabel="sqlvar_t Structure">
      <title>sqlvar_t Structure</title>
 
      <para>
@@ -4244,7 +4244,7 @@ typedef struct sqlvar_struct sqlvar_t;
      </para>
     </sect4>
 
-    <sect4 id="ecpg-sqlda-sqlname">
+    <sect4 id="ecpg-sqlda-sqlname" xreflabel="struct sqlname Structure">
      <title>struct sqlname Structure</title>
 
      <para>
@@ -4283,7 +4283,7 @@ struct sqlname
     </sect4>
    </sect3>
 
-   <sect3 id="ecpg-sqlda-output">
+   <sect3 id="ecpg-sqlda-output" xreflabel="Retrieving a Result Set Using an SQLDA">
     <title>Retrieving a Result Set Using an SQLDA</title>
 
     <procedure>
@@ -4372,7 +4372,7 @@ switch (v.sqltype)
     </para>
    </sect3>
 
-   <sect3 id="ecpg-sqlda-input">
+   <sect3 id="ecpg-sqlda-input" xreflabel="Passing Query Parameters Using an SQLDA">
     <title>Passing Query Parameters Using an SQLDA</title>
 
     <procedure>
@@ -4458,7 +4458,7 @@ free(sqlda2);
     </para>
    </sect3>
 
-   <sect3 id="ecpg-sqlda-example">
+   <sect3 id="ecpg-sqlda-example" xreflabel="A Sample Application Using SQLDA">
     <title>A Sample Application Using SQLDA</title>
 
     <para>
@@ -4813,7 +4813,7 @@ tup_deleted = 0 (type: 9)
   </sect2>
  </sect1>
 
- <sect1 id="ecpg-errors">
+ <sect1 id="ecpg-errors" xreflabel="Error Handling">
   <title>Error Handling</title>
 
   <para>
@@ -4838,7 +4838,7 @@ tup_deleted = 0 (type: 9)
    </itemizedlist>
   </para>
 
-  <sect2 id="ecpg-whenever">
+  <sect2 id="ecpg-whenever" xreflabel="Setting Callbacks">
    <title>Setting Callbacks</title>
 
    <para>
@@ -5029,7 +5029,7 @@ static void set_error_handler(void)
    </para>
   </sect2>
 
-  <sect2 id="ecpg-sqlca">
+  <sect2 id="ecpg-sqlca" xreflabel="sqlca">
    <title>sqlca</title>
 
    <para>
@@ -5172,7 +5172,7 @@ sqlstate: 42P01
    </para>
   </sect2>
 
-  <sect2 id="ecpg-sqlstate-sqlcode">
+  <sect2 id="ecpg-sqlstate-sqlcode" xreflabel="SQLSTATE vs. SQLCODE">
    <title><literal>SQLSTATE</literal> vs. <literal>SQLCODE</literal></title>
 
    <para>
@@ -5684,7 +5684,7 @@ while (1)
   </sect2>
  </sect1>
 
- <sect1 id="ecpg-preproc">
+ <sect1 id="ecpg-preproc" xreflabel="Preprocessor Directives">
   <title>Preprocessor Directives</title>
 
   <para>
@@ -5693,7 +5693,7 @@ while (1)
    file.
   </para>
 
-  <sect2 id="ecpg-include">
+  <sect2 id="ecpg-include" xreflabel="Including Files">
    <title>Including Files</title>
 
    <para>
@@ -5752,7 +5752,7 @@ EXEC SQL INCLUDE "<replaceable>filename</replaceable>";
    </note>
   </sect2>
 
-  <sect2 id="ecpg-define">
+  <sect2 id="ecpg-define" xreflabel="The define and undef Directives">
    <title>The define and undef Directives</title>
    <para>
     Similar to the directive <literal>#define</literal> that is known from C,
@@ -5803,7 +5803,7 @@ EXEC SQL UPDATE Tbl SET col = MYNUMBER;
    </para>
   </sect2>
 
-  <sect2 id="ecpg-ifdef">
+  <sect2 id="ecpg-ifdef" xreflabel="ifdef, ifndef, elif, else, and endif Directives">
    <title>ifdef, ifndef, elif, else, and endif Directives</title>
    <para>
    You can use the following directives to compile code sections conditionally:
@@ -5898,7 +5898,7 @@ EXEC SQL endif;
   </sect2>
  </sect1>
 
-  <sect1 id="ecpg-process">
+  <sect1 id="ecpg-process" xreflabel="Processing Embedded SQL Programs">
   <title>Processing Embedded SQL Programs</title>
 
   <para>
@@ -5986,7 +5986,7 @@ ECPG = ecpg
   </para>
  </sect1>
 
- <sect1 id="ecpg-library">
+ <sect1 id="ecpg-library" xreflabel="Library Functions">
   <title>Library Functions</title>
 
   <para>
@@ -6060,7 +6060,7 @@ ECPG = ecpg
   </itemizedlist>
  </sect1>
 
- <sect1 id="ecpg-lo">
+ <sect1 id="ecpg-lo" xreflabel="Large Objects">
   <title>Large Objects</title>
 
   <para>
@@ -6175,7 +6175,7 @@ main(void)
   </example>
  </sect1>
 
- <sect1 id="ecpg-cpp">
+ <sect1 id="ecpg-cpp" xreflabel="C++ Applications">
   <title><acronym>C++</acronym> Applications</title>
 
   <para>
@@ -6211,7 +6211,7 @@ main(void)
    about that.
   </para>
 
-  <sect2 id="ecpg-cpp-scope">
+  <sect2 id="ecpg-cpp-scope" xreflabel="Scope for Host Variables">
    <title>Scope for Host Variables</title>
 
    <para>
@@ -6290,7 +6290,7 @@ void TestCpp::test()
    </para>
   </sect2>
 
-  <sect2 id="ecpg-cpp-and-c">
+  <sect2 id="ecpg-cpp-and-c" xreflabel="C++ Application Development with External C Module">
    <title>C++ Application Development with External C Module</title>
 
    <para>
@@ -6458,7 +6458,7 @@ c++ test_cpp.o test_mod.o -lecpg -o test_cpp
   </sect2>
  </sect1>
 
- <sect1 id="ecpg-sql-commands">
+ <sect1 id="ecpg-sql-commands" xreflabel="Embedded SQL Commands">
   <title>Embedded SQL Commands</title>
 
   <para>
@@ -8215,7 +8215,7 @@ main(void)
   </refentry>
  </sect1>
 
- <sect1 id="ecpg-informix-compat">
+ <sect1 id="ecpg-informix-compat" xreflabel="Informix Compatibility Mode">
   <title><productname>Informix</productname> Compatibility Mode</title>
   <para>
    <command>ecpg</command> can be run in a so-called <firstterm>Informix compatibility mode</firstterm>. If
@@ -8269,7 +8269,7 @@ $COMMIT;
    find support in ECPG for that either.
   </para>
 
-  <sect2 id="ecpg-informix-types">
+  <sect2 id="ecpg-informix-types" xreflabel="Additional Types">
    <title>Additional Types</title>
    <para>
     The Informix-special "string" pseudo-type for storing right-trimmed character string data is now
@@ -8285,7 +8285,7 @@ EXEC SQL FETCH MYCUR INTO :userid;
    </para>
   </sect2>
 
-  <sect2 id="ecpg-informix-statements">
+  <sect2 id="ecpg-informix-statements" xreflabel="Additional/Missing Embedded SQL Statements">
    <title>Additional/Missing Embedded SQL Statements</title>
    <para>
     <variablelist>
@@ -8327,7 +8327,7 @@ EXEC SQL CLOSE DATABASE;
    </para>
   </sect2>
 
-  <sect2 id="ecpg-informix-sqlda">
+  <sect2 id="ecpg-informix-sqlda" xreflabel="Informix-compatible SQLDA Descriptor Areas">
    <title>Informix-compatible SQLDA Descriptor Areas</title>
    <para>
     Informix-compatible mode supports a different structure than the one described in
@@ -8604,7 +8604,7 @@ EXEC SQL INCLUDE sqlda.h;
    </para>
   </sect2>
 
-  <sect2 id="ecpg-informix-functions">
+  <sect2 id="ecpg-informix-functions" xreflabel="Additional Functions">
    <title>Additional Functions</title>
    <para>
     <variablelist>
@@ -9662,7 +9662,7 @@ risnull(CINTTYPE, (char *) &i);
    </para>
   </sect2>
 
-  <sect2 id="ecpg-informix-constants">
+  <sect2 id="ecpg-informix-constants" xreflabel="Additional Constants">
    <title>Additional Constants</title>
    <para>
     Note that all constants here describe errors and all of them are defined
@@ -9830,7 +9830,7 @@ risnull(CINTTYPE, (char *) &i);
   </sect2>
  </sect1>
 
- <sect1 id="ecpg-oracle-compat">
+ <sect1 id="ecpg-oracle-compat" xreflabel="Oracle Compatibility Mode">
   <title><productname>Oracle</productname> Compatibility Mode</title>
   <para>
    <command>ecpg</command> can be run in a so-called <firstterm>Oracle
@@ -9866,7 +9866,7 @@ risnull(CINTTYPE, (char *) &i);
   </para>
  </sect1>
 
- <sect1 id="ecpg-develop">
+ <sect1 id="ecpg-develop" xreflabel="Internals">
   <title>Internals</title>
 
   <para>
diff --git a/doc/src/sgml/event-trigger.sgml b/doc/src/sgml/event-trigger.sgml
index c10627554bd..c82d8d8f116 100644
--- a/doc/src/sgml/event-trigger.sgml
+++ b/doc/src/sgml/event-trigger.sgml
@@ -21,7 +21,7 @@
    SQL.
   </para>
 
-  <sect1 id="event-trigger-definition">
+  <sect1 id="event-trigger-definition" xreflabel="Overview of Event Trigger Behavior">
    <title>Overview of Event Trigger Behavior</title>
 
    <para>
@@ -36,7 +36,7 @@
      Support for additional events may be added in future releases.
    </para>
 
-   <sect2 id="event-trigger-login">
+   <sect2 id="event-trigger-login" xreflabel="login">
     <title>login</title>
 
    <para>
@@ -161,7 +161,7 @@
    </para>
    </sect2>
 
-   <sect2 id="event-trigger-aborted-transactions">
+   <sect2 id="event-trigger-aborted-transactions" xreflabel="Event Triggers in Aborted Transactions">
     <title>Event Triggers in Aborted Transactions</title>
 
    <para>
@@ -177,7 +177,7 @@
    </para>
    </sect2>
 
-   <sect2 id="event-trigger-creating">
+   <sect2 id="event-trigger-creating" xreflabel="Creating Event Triggers">
     <title>Creating Event Triggers</title>
 
    <para>
@@ -203,7 +203,7 @@
    </sect2>
   </sect1>
 
-  <sect1 id="event-trigger-interface">
+  <sect1 id="event-trigger-interface" xreflabel="Writing Event Trigger Functions in C">
    <title>Writing Event Trigger Functions in C</title>
 
    <indexterm zone="event-trigger-interface">
@@ -317,7 +317,7 @@ typedef struct EventTriggerData
    </para>
   </sect1>
 
-  <sect1 id="event-trigger-example">
+  <sect1 id="event-trigger-example" xreflabel="A Complete Event Trigger Example">
    <title>A Complete Event Trigger Example</title>
 
    <para>
@@ -410,7 +410,7 @@ COMMIT;
    </para>
   </sect1>
 
-  <sect1 id="event-trigger-table-rewrite-example">
+  <sect1 id="event-trigger-table-rewrite-example" xreflabel="A Table Rewrite Event Trigger Example">
    <title>A Table Rewrite Event Trigger Example</title>
 
    <para>
@@ -464,7 +464,7 @@ CREATE EVENT TRIGGER no_rewrite_allowed
    </para>
  </sect1>
 
-  <sect1 id="event-trigger-database-login-example">
+  <sect1 id="event-trigger-database-login-example" xreflabel="A Database Login Event Trigger Example">
     <title>A Database Login Event Trigger Example</title>
 
     <para>
